# coding: utf-8

"""
    CardPay REST API

    Welcome to the CardPay REST API. The CardPay API uses HTTP verbs and a REST resources endpoint structure (see more info about REST). Request and response payloads are formatted as JSON. Merchant uses API to create payments, refunds, payouts or recurrings, check or update transaction status and get information about created transactions. In API authentication process based on OAuth 2.0 standard. For recent changes see changelog section.  # noqa: E501

    OpenAPI spec version: 3.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cardpay.model.plan import Plan  # noqa: F401,E501


class ScheduledData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dynamic_descriptor': 'str',
        'generate_token': 'bool',
        'initiator': 'str',
        'note': 'str',
        'plan': 'Plan',
        'subscription_start': 'datetime'
    }

    attribute_map = {
        'dynamic_descriptor': 'dynamic_descriptor',
        'generate_token': 'generate_token',
        'initiator': 'initiator',
        'note': 'note',
        'plan': 'plan',
        'subscription_start': 'subscription_start'
    }

    def __init__(self, dynamic_descriptor=None, generate_token=None, initiator=None, note=None, plan=None, subscription_start=None):  # noqa: E501
        """ScheduledData - a model defined in Swagger"""  # noqa: E501

        self._dynamic_descriptor = None
        self._generate_token = None
        self._initiator = None
        self._note = None
        self._plan = None
        self._subscription_start = None
        self.discriminator = None

        if dynamic_descriptor is not None:
            self.dynamic_descriptor = dynamic_descriptor
        if generate_token is not None:
            self.generate_token = generate_token
        self.initiator = initiator
        if note is not None:
            self.note = note
        if plan is not None:
            self.plan = plan
        if subscription_start is not None:
            self.subscription_start = subscription_start

    @property
    def dynamic_descriptor(self):
        """Gets the dynamic_descriptor of this ScheduledData.  # noqa: E501


        :return: The dynamic_descriptor of this ScheduledData.  # noqa: E501
        :rtype: str
        """
        return self._dynamic_descriptor

    @dynamic_descriptor.setter
    def dynamic_descriptor(self, dynamic_descriptor):
        """Sets the dynamic_descriptor of this ScheduledData.


        :param dynamic_descriptor: The dynamic_descriptor of this ScheduledData.  # noqa: E501
        :type: str
        """
        if dynamic_descriptor is not None and len(dynamic_descriptor) > 25:
            raise ValueError("Invalid value for `dynamic_descriptor`, length must be less than or equal to `25`")  # noqa: E501
        if dynamic_descriptor is not None and len(dynamic_descriptor) < 0:
            raise ValueError("Invalid value for `dynamic_descriptor`, length must be greater than or equal to `0`")  # noqa: E501

        self._dynamic_descriptor = dynamic_descriptor

    @property
    def generate_token(self):
        """Gets the generate_token of this ScheduledData.  # noqa: E501


        :return: The generate_token of this ScheduledData.  # noqa: E501
        :rtype: bool
        """
        return self._generate_token

    @generate_token.setter
    def generate_token(self, generate_token):
        """Sets the generate_token of this ScheduledData.


        :param generate_token: The generate_token of this ScheduledData.  # noqa: E501
        :type: bool
        """

        self._generate_token = generate_token

    @property
    def initiator(self):
        """Gets the initiator of this ScheduledData.  # noqa: E501


        :return: The initiator of this ScheduledData.  # noqa: E501
        :rtype: str
        """
        return self._initiator

    @initiator.setter
    def initiator(self, initiator):
        """Sets the initiator of this ScheduledData.


        :param initiator: The initiator of this ScheduledData.  # noqa: E501
        :type: str
        """
        if initiator is None:
            raise ValueError("Invalid value for `initiator`, must not be `None`")  # noqa: E501
        if initiator is not None and not re.search(r'mit|cit', initiator):  # noqa: E501
            raise ValueError(r"Invalid value for `initiator`, must be a follow pattern or equal to `/mit|cit/`")  # noqa: E501

        self._initiator = initiator

    @property
    def note(self):
        """Gets the note of this ScheduledData.  # noqa: E501


        :return: The note of this ScheduledData.  # noqa: E501
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this ScheduledData.


        :param note: The note of this ScheduledData.  # noqa: E501
        :type: str
        """
        if note is not None and len(note) > 100:
            raise ValueError("Invalid value for `note`, length must be less than or equal to `100`")  # noqa: E501
        if note is not None and len(note) < 0:
            raise ValueError("Invalid value for `note`, length must be greater than or equal to `0`")  # noqa: E501

        self._note = note

    @property
    def plan(self):
        """Gets the plan of this ScheduledData.  # noqa: E501

        Plan data  # noqa: E501

        :return: The plan of this ScheduledData.  # noqa: E501
        :rtype: Plan
        """
        return self._plan

    @plan.setter
    def plan(self, plan):
        """Sets the plan of this ScheduledData.

        Plan data  # noqa: E501

        :param plan: The plan of this ScheduledData.  # noqa: E501
        :type: Plan
        """

        self._plan = plan

    @property
    def subscription_start(self):
        """Gets the subscription_start of this ScheduledData.  # noqa: E501

        The time in 'yyyy-MM-dd' format when subscription will actually become activated (grace period).Leave it empty to activate subscription at once without any grace period applied.  # noqa: E501

        :return: The subscription_start of this ScheduledData.  # noqa: E501
        :rtype: datetime
        """
        return self._subscription_start

    @subscription_start.setter
    def subscription_start(self, subscription_start):
        """Sets the subscription_start of this ScheduledData.

        The time in 'yyyy-MM-dd' format when subscription will actually become activated (grace period).Leave it empty to activate subscription at once without any grace period applied.  # noqa: E501

        :param subscription_start: The subscription_start of this ScheduledData.  # noqa: E501
        :type: datetime
        """

        self._subscription_start = subscription_start

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if value is not None:
                    result[attr] = value
        if issubclass(ScheduledData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScheduledData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
